<?php
/**
 * Project     Newsletter for Joomla 1.5.x
 * Release     2.0.4
 * @package    Communicator
 * @subpackage Component
 * @version    $Id$
 * @link       http://joomlacode.org/gf/project/communicator/
 * @copyright  Copyright (c) 2008 Stefan Granholm, Copyright 2009, 2010 Erik Damke - All rights reserved
 * @license    http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php for details
 *
 * Authors: Stefan Granholm (http://www.granholmcms.com), Erik Damke (commqc20@jocoflex.com)
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * CHANGELOG
 * (function definition required by phpDocumentor)
 */
function CHANGELOG()
{
/*
1. Copyright and disclaimer
---------------------------
This application is opensource software released under the GPL.  Please
see source code and the LICENSE.php file


2. Changelog
------------
This is a non-exhaustive (but still near complete) changelog for
Communicator including beta and release candidate versions.
Our thanks to all those people who've contributed bug reports and code fixes.

Legend:

* -> Security Fix
# -> Bug Fix
$ -> Language fix or change
+ -> Addition
^ -> Change
- -> Removed
! -> Note

-------------------- 2.0.4 Stable Release [01-January 2010 aka 'New Decade'] ------------
 # fix access problem for Frontend Newsletter
 ^ add back newsletter delete function at frontend (removed with V2.0.3)
 # [#15393] abilty to send existing newsletter from front end
 # configurable date formatting rule now applies to all dates in the frontend
-------------------- 2.0.3 Stable Release [26-November 2009 aka 'Thanksgiving'] ------------
 + ability to turn off communicator footer at the frontend
 + ability to define frontend listing access (NONE, ..., publisher, ..., super admins)  
 # [#15628] Name length delimiter does not work
 # [#18736] 'Name' field displayed in unsubscribe form whatever module configuration
 ^ remove delete newsletter function from frontend
 # [#18735] Unsubscribe: Error in Javascript
 # fix check for publishing date in showNewsletters()
 ^ increase number of articles in selectlist when composing newsletters (max. now 100)
 # [#17865] Call to undefined function: jerror()
-------------------- 2.0.2 Stable Release [21-July 2009] ----------------
26-September-2009 
 + add turkish translation (tr-TR), thanks to Tolga
-------------------- 2.0.2 Stable Release [21-July 2009 aka 'Eagle'] ----------------
 # [#17285] Missing Argument 6 (in the backend) 
-------------------- 2.0.1 Stable Release [20-July 2009] ----------------
 # add und fix User friendly URL support in frontend
 + [#15546] Usability issues (disable subscribe button)
-------------------- 2.0.0b Stable Release [10. June 2009] ----------------
10-June-2009
 + add portugues translation (pt-BR), thanks to Alvaro Soares
06-June-2009
 + add swedish translation (sv-SE), thanks to Sverker Ehn
28-May-2009
 $ fix typo in portuguese translation (CM_SUBSCRIBE_MESSAGE)
17-May-2009
 $ fix typo in italian translation (CM_NEWSLETTER_FOOTER)
-------------------- 2.0.0 Stable Release [10-May 2009 aka 'Mothers Day'] ----------------
 # No user displayed in backend when selected display 'all'
 ^ move communicator.css, communicator.js and communicator.png files to /assets/ subdirectory
-------------------- 2.0.0RC3 Release [10-April 2009 aka 'Easter Egg'] ------------------
10-Apr-2009
 # [#15835] wrongly placed @
 # [#15657] Will only delete one subscriber at a time
 $ new language Support for portuguese (pt-PT), thanks to João Pinheiro
30-Mar-2009
 # fix component install package to install under Joomla 1.5.10
 # [#15720] Error when adding duplicate addresses from backend
 # [#15658] Untranslated strings
 # [#15661] Import need to be in UTF-8 (docu fix)
 + [#15606] Supress the 'delete' column on frontpage
 + provide 'replyto' configuration field for newsletter management
 $ lots of additional translation string added
21-Mar-2009
 # [#15520] Undefined variable: my in ... default.php (2)
17-Mar-2009
 # [#15520] Undefined variable: my in ... default.php (1)
15-Mar-2009
 + add Norwegian language support (thanks to Erik Reitan)
03-Mar-2009
 # [#15290] Subscriber Management - Remove Fails
 # User Name field not visible for subscribe
-------------------- 2.0.0RC2c Release [27-February 2009] ------------------
 # [#15271] Small corrections of fr-FR_communicator_lang_both_2.0.0RC2
 ^ update Hungarian Language Packs (formal & informal)
-------------------- 2.0.0RC2b Release [26-February 2009] ------------------
 # [#15259] Update french translation to RC2
-------------------- 2.0.0RC2 Release [24-February 2009] ------------------
24-Feb-2009 Erik Damke
 # [#14873] untranslated 'Powered by'
 $ add lots of additional translation strings (translators please contact me before doing updates!)
 + Configure senders EMail and Name for Newsletter
 ^ Make 'unsubscribe' button optional in module
 ^ Make standard email checking the default (was enhanced check)
 + Add configuration of date display format for component
 + publish the subscriber modules (Yeh !)
-------------------- 2.0.0RC1b Release [6-February 2009] ------------------
06-Feb-2009 Erik Damke
 + add Hungarian (hu-HU) language Pack (formal and informal), thanks to Herczeg Jozsef Tamas
   from the Hungarian Joomla User group.
03-Feb-2009 Erik Damke
 + add Dutch (nl-NL) language Pack, thanks to Peter de Lange.
02-Feb-2009 Erik Damke
 ^ The language packs for the following languages where refreshed due to
   an installer bug in Joomla-Core: ca-ES, de-DE, es-ES, fr-FR.
   No code changes in the component.
-------------------- 2.0.0RC1 Release [31-January-2009] ------------------
31-Jan-2009 Erik Damke
 - remove all language support from component installation (except en-GB)
 + create individual installation for each file (for better tracking)
 # Re-installation of component preserves existing newsletter
 ^ Make message 'CM_NEWSLETTER_MUST_HAVE_SUBJECT' translatable
 ^ Make message 'CM_PLEASE_COMPLETE_ALL_FIELDS' translatable
 ^ Fix message 'DO YOU REALLY WANT TO UNSUBSCRIBE FROM OUR NEWSLETTER SERVICE?' for Module
 ^ rename CHANGELOG.txt, LICENSE.txt and README.txt to *.php files
 ^ fixed some french and spanish messages
 # [#14282] Can not subscribe when User friendly URL is turned on
 # [#14498] Image and URL links in HTML are broken
-------------------- 1.7.9 Release [by Stefan Granholm] ------------------
(change logs 1.7.4 to 1.7.9 missing)
Version 1.7.3
* Fixed Danish language not UTF-8
^ Changed icons
* Fixed numerous display issues with the front-end
^ Updated front-end language file
* Fixed CSV import
^ Updated footer class

Version 1.7.2
* Updated Hungarian
* Fixed the extra items that show up in Communicator once the user submits his name and email
* Fixed backend link

Version 1.7.1
* Fixed some missing translations
+ Added Parameter translation strings
^ Updated English language file
^ Updated installer

Version 1.7
^ Updated Hungarian translation
+ Added menu translation
* Fixed English language file
+ Added Egyptian
* Fixed Danish language file


Version 1.6
^ Changed all language files to 1.5 mode
+ Added option to delete all non-confirmed subscribers
* Changed Granholm Hosting to Granholm CMS
^ Updated XML installer file
^ Moved content to site and admin sections

Version 1.5
* Fixed the Compose newsletter not working
* Fixed URLs using local path instead of URL
* Fixed CSS styling front-end
* Fixed tooltips not showing on configuration page
^ Changed front-end notification from text to Joomla notification bar
+ Added missing language tags

Version 1.0
+ Initial conversion from Joomla 1.0.x to Joomla 1.5.x

*/
}
//-- End-Of-File